//+------------------------------------------------------------------+
//|                                                ZeroLAG Bands.mq4 |
//|                                               Written by Linuxser|   
//|                                       http://www.linuxser.com.ar |    
//|Credits:                                                          |
//|Zero Lag calculation is based on the code made by marynarz15@wp.pl|
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Red
//---- indicator parameters
extern string abc="-----------Bands Options------------------------";
extern int BandsLength = 20;
extern double BandsDeviation = 2;
extern double BandsShift = 0;
extern string cba="-----------Moving Average Options---------------";
extern int nZLMAPeriod = 20;
extern int nZLMAShift = 0;
extern int nZLMAMethod = 1;
extern int nZLMAApplPrice = 0;
extern string bca="----------Smoothing Options---------------------";
extern int nZLMASmPeriod = 20;
extern int nZLMASmShift = 0;
extern int nZLMASmMethod = 0;


//---- indicator buffers
double dZLMABuffer[];
double bup[];
double blow[];
double dWorkBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);
   SetIndexBuffer(0, bup);
   SetIndexBuffer(1, blow);
   SetIndexBuffer(2, dZLMABuffer);
   SetIndexBuffer(3, dWorkBuffer);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);
   
   SetIndexLabel(0,"ZeroLag BUP");
   SetIndexLabel(1,"ZeroLag BLOW");
   SetIndexLabel(2,"ZeroLag MA");
   IndicatorShortName("ZeroLAG Bands(" + nZLMAPeriod + ", " + nZLMAShift + ", " + 
                      nZLMAMethod + ", " + nZLMAApplPrice + ")");
   SetIndexDrawBegin(0, nZLMAPeriod + nZLMASmPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   double dMA;   
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
   for(int i = 0; i < limit; i++)
       dWorkBuffer[i] = iMA(NULL, 0, nZLMAPeriod, nZLMAShift, nZLMAMethod, nZLMAApplPrice, i);
   for(i = 0; i < limit; i++)
     {
       dMA = iMAOnArray(dWorkBuffer, 0, nZLMASmPeriod, nZLMASmShift, nZLMASmMethod, i);
       dZLMABuffer[i] = dWorkBuffer[i] + dWorkBuffer[i] - dMA;
     }
     
   for(i = 0; i < limit; i++)
     {
     bup[i]=iBandsOnArray(dZLMABuffer,Bars,BandsLength,BandsDeviation,BandsShift,MODE_UPPER,i);
	  blow[i]=iBandsOnArray(dZLMABuffer,Bars,BandsLength,BandsDeviation,BandsShift,MODE_LOWER,i);
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+